__gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc > Struct Template Reference

`#include <node.hpp>`

## Public Types

typedef _Alloc::template rebind< metadata_type >::other::const_reference | metadata_const_reference
typedef _Alloc::template rebind< metadata_type >::other::reference | metadata_reference
typedef Metadata | metadata_type
typedef _Alloc::template rebind< rb_tree_node_< Value_Type, Metadata, _Alloc > >::other::pointer | node_pointer
typedef Value_Type | value_type

## Public Member Functions

metadata_reference | get_metadata ()
metadata_const_reference | get_metadata () const
bool | special () const

## Public Attributes

metadata_type | m_metadata
node_pointer | m_p_left
node_pointer | m_p_parent
node_pointer | m_p_right
bool | m_red
value_type | m_value

## Detailed Description

template<typename Value_Type, class Metadata, typename _Alloc>
struct __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >

Node for Red-Black trees.

Definition at line 52 of file rb_tree_map_/node.hpp.

## Member Typedef Documentation

## metadata_const_reference

template<typename Value_Type , class Metadata , typename _Alloc >

typedef _Alloc::template rebind<metadata_type>::other::const_reference __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::metadata_const_reference

Definition at line 74 of file rb_tree_map_/node.hpp.

## metadata_reference

template<typename Value_Type , class Metadata , typename _Alloc >

typedef _Alloc::template rebind<metadata_type>::other::reference __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::metadata_reference

Definition at line 69 of file rb_tree_map_/node.hpp.

## metadata_type

template<typename Value_Type , class Metadata , typename _Alloc >

typedef Metadata __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::metadata_type

Definition at line 56 of file rb_tree_map_/node.hpp.

## node_pointer

template<typename Value_Type , class Metadata , typename _Alloc >

typedef _Alloc::template rebind<rb_tree_node_<Value_Type,Metadata,_Alloc>>::other::pointer __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::node_pointer

Definition at line 64 of file rb_tree_map_/node.hpp.

## value_type

template<typename Value_Type , class Metadata , typename _Alloc >

typedef Value_Type __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::value_type

Definition at line 55 of file rb_tree_map_/node.hpp.

## Member Function Documentation

## get_metadata() [1/2]

template<typename Value_Type , class Metadata , typename _Alloc >

metadata_reference __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::get_metadata | ( |  | ) |

inline

Definition at line 85 of file rb_tree_map_/node.hpp.

## get_metadata() [2/2]

template<typename Value_Type , class Metadata , typename _Alloc >

metadata_const_reference __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::get_metadata | ( |  | ) | const

inline

Definition at line 81 of file rb_tree_map_/node.hpp.

## special()

template<typename Value_Type , class Metadata , typename _Alloc >

bool __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::special | ( |  | ) | const

inline

Definition at line 77 of file rb_tree_map_/node.hpp.

## Member Data Documentation

## m_metadata

template<typename Value_Type , class Metadata , typename _Alloc >

metadata_type __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::m_metadata

Definition at line 102 of file rb_tree_map_/node.hpp.

## m_p_left

template<typename Value_Type , class Metadata , typename _Alloc >

node_pointer __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::m_p_left

Definition at line 97 of file rb_tree_map_/node.hpp.

## m_p_parent

template<typename Value_Type , class Metadata , typename _Alloc >

node_pointer __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::m_p_parent

Definition at line 99 of file rb_tree_map_/node.hpp.

## m_p_right

template<typename Value_Type , class Metadata , typename _Alloc >

node_pointer __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::m_p_right

Definition at line 98 of file rb_tree_map_/node.hpp.

## m_red

template<typename Value_Type , class Metadata , typename _Alloc >

bool __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::m_red

Definition at line 101 of file rb_tree_map_/node.hpp.

## m_value

template<typename Value_Type , class Metadata , typename _Alloc >

value_type __gnu_pbds::detail::rb_tree_node_< Value_Type, Metadata, _Alloc >::m_value

Definition at line 100 of file rb_tree_map_/node.hpp.

The documentation for this struct was generated from the following file:

- rb_tree_map_/node.hpp